<template>
  <v-container>
    <v-card>
      <v-card-title>
        Create Group
      </v-card-title>
      <v-container>
        <validation-observer
          ref="observer"
          v-slot="{ invalid }"
        >
          <v-form @submit.prevent="submit(validate)">
            <form-field
              v-for="field in fields"
              :key="field.id"
              :data='group'
              :field="field"
            />
            <v-card-actions>
              <v-spacer />
              <v-btn
                type="submit"
                :disabled="invalid"
              >
                Create
              </v-btn>
            </v-card-actions>
          </v-form>
        </validation-observer>
      </v-container>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue'
import { fields } from '@/util/group-fields'
import FormField from '@/components/FormField.vue'

import { post } from '../util/http'

export default Vue.extend({
  name: 'create-group-page',
  components: { FormField },
  data () {
    return {
      fields,
      group: {} as { [key: string]: string }
    }
  },
  mounted () {
    this.clear()
  },
  methods: {
    clear () {
      const group: { [key: string]: string } = {}

      fields.forEach((field) => {
        this.group[field.id] = ''
      })

      this.group = group
    },
    async submit () {
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      if (!(this.$refs.observer as any).validate()) { return }

      try {
        await post('group', { create: this.group })

        this.clear()
      } catch (e) {
        alert(e.message)
      }
    }
  }
})
</script>
